Attribute VB_Name = "Module1"
Option Explicit
'Constatntes pour fonction FiltreSaisie
Public Const TOUT = 1
Public Const MAJUSCULES = 2
Public Const CHIFFRES = 3
Public Const CHIFFRESSPACE = 4
Public Const CHIFFRESMOINS = 5
Public Const MONNAIE = 6
Public Const DATES = 7
Public Const INITIALE = 8
Public Const TELEPHONE = 9
Public Const URL = 10
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

'Constantes pour feuille rpertoire
Public Const AJOUT = 1
Public Const MODIF = 2

'Variables globales
Public IniFile$
Public Calepin$(2, 2000), NbContact%
Public Messages As New Collection, NbMessage%
Public Login$, Pass$, Enregistrer%

Public Function EncodeURL$(ByVal chaine$)
  'V 1.0
  'Paramtres : Chaine  encoder
  'Retour : Chaine au format URL
  Dim i%
  For i% = 1 To Len(chaine$)
    Select Case Asc(Mid$(chaine$, i%, 1))
    Case 32
      EncodeURL = EncodeURL & "+"
    Case 42, 45, 46, 48 To 57, 64 To 90, 97 To 122
      EncodeURL = EncodeURL & Mid$(chaine$, i%, 1)
    Case Else
      EncodeURL = EncodeURL & "%" & DcToHex$(Asc(Mid$(chaine$, i%, 1)), 2)
    End Select
  Next i%
End Function

Public Function DcToHex$(ByVal X, Optional Longueur)
  'V 2.0
  'Paramtres : un nombre
  'Longueur : Longueur minimale de la chaine produite, complte ventuellement par des zros  gauche.
  'Retour : une chaine reprsentant le nombre en hexadcimal
  DcToHex$ = Hex$(X)
  If Len(DcToHex$) < Longueur Then DcToHex$ = String$(Longueur - Len(DcToHex$), "0") & DcToHex$
End Function

Public Sub FiltreSaisie(z As TextBox, X%, mode%)
  'V 3.1
  'Paramtres : un controle TEXTBOX
  '             le code% ASCII d'un caractre
  '             un entier
  'Action : Le texte de TEXTBOX est filtr selon diffrents critres
  'Mode% 1 Tout car., pas d'espace en 1ere position
  'Mode% 2 Transforme en majuscules
  'Mode% 3 Chiffres seuls
  'Mode% 4 Chiffres et espace
  'Mode% 5 Chiffres et -
  'Mode% 6 Valeur montaire
  'Mode% 7 Date
  'Mode% 8 Initiale en majuscule
  'Mode% 9 Numro de tlphone
  'Mode% 10 Url
  Dim i%
  Dim last As Boolean
  last = IIf(z.SelStart <= Len(z.Text) - 1, False, True) 'Vrai si le point d'insertion est derrire le dernier caractre
  If z.SelStart = 0 And X% = 32 Then                    'Elimine espace en 1re position
    X% = 0
    Exit Sub
  End If
  If X% = 8 Then Exit Sub                               'Backspace toujours actif
  Select Case mode%
  Case TOUT
    'Sauf espace en 1re position
  Case MAJUSCULES
    X% = Asc(UCase$(Chr(X)))
  Case INITIALE
    If z.SelStart = 0 Then X% = Asc(UCase$(Chr$(X%)))
  Case CHIFFRES
    If NotNumber(X%) Then X% = 0
  Case CHIFFRESSPACE
    If NotNumber(X%) And X% <> 32 Then X% = 0
  Case CHIFFRESMOINS
    If NotNumber(X%) And X% <> 45 Then X% = 0
  Case MONNAIE
    If X% = 46 Then X% = 44 'Transforme point en virgule
    If NotNumber(X%) And X% <> 44 And X% <> 45 Then X% = 0 'Ne garder que les chiffres, la virgule et le '-'
    If z.SelLength = Len(z.Text) Then Exit Sub
    'Empcher le '-' ailleurs qu'en premire colonne
    If X% = 45 And z.SelStart > 0 Then X% = 0
    'Empcher plus d'un '-'
    If X% = 45 And InStr(z.Text, "-") > 0 Then X% = 0
    'Empcher une frappe avant le '-'
    If z.SelStart = 0 And InStr(z.Text, "-") > 0 Then X% = 0
    'Empcher plus d'une virgule
    If X% = 44 And InStr(z.Text, ",") > 0 Then X% = 0
    'Empcher virgule dcimale avant plus de 2 dcimales
    i% = InStr(z.Text, " ") - 1 'Pour liminer le symbole montaire qui suit l'espace
    If i% = -1 Then i% = Len(z.Text) Else i% = i%
    If X% = 44 And z.SelStart < i% - 2 Then X% = 0
    'Empcher plus de deux dcimales derrire la virgule
    i% = InStr(z.Text, ",")
    If Not NotNumber(X%) And i% > 0 And z.SelStart >= i% And Len(z.Text) >= i% + 2 Then X% = 0
  Case DATES
    If NotNumber(X%) Then X% = 47 'Transforme tout autre car. qu'un chiffre en '/'
    If z.SelLength = Len(z.Text) Then Exit Sub
    'Empcher plus de 2 '/'
    i% = InStr(z.Text, "/")
    If X% = 47 And i% > 0 Then If InStr(i% + 1, z.Text, "/") > 0 Then X% = 0
    'Empcher un '/' en colonne 1 ou >  6
    If X% = 47 And (z.SelStart = 0 Or z.SelStart > 5) Then X% = 0
    'Empcher 2 '/' conscutifs
    If X% = 47 And z.SelStart > 0 Then If Asc(Mid$(z.Text, z.SelStart)) = 47 Then X% = 0 'Regarde  gauche
    If X% = 47 And Not last Then If Asc(Mid$(z.Text, z.SelStart + 1)) = 47 Then X% = 0 'Regarde  droite
    'Empcher plus de 2 chiffres pour le jour
    If X% <> 47 And z.SelStart <= 2 And Len(z.Text) >= 2 And IsNumeric(Left$(z.Text, 2)) Then X% = 0
    'Empcher plus de 2 chiffres pour le mois
    i% = InStr(z.Text, "/")
    If X% <> 47 And i% > 0 And z.SelStart >= i% And z.SelStart <= i% + 2 And Len(z.Text) >= i% + 2 And IsNumeric(Mid$(z.Text, i% + 1, 2)) Then X% = 0
    'Empcher plus de 4 chiffres pour l'anne
    i% = InStr(z.Text, "/")
    If X% <> 47 And i% > 0 Then
      i% = InStr(i% + 1, z.Text, "/")
      If i% > 0 And z.SelStart >= i% And Len(z.Text) >= i% + 4 Then X% = 0
    End If
  Case TELEPHONE
    If X% = 46 Then X% = 32 'Transforme point en espace
    If NotNumber(X%) And X% <> 43 And X% <> 32 Then X% = 0  'Ne garder que les chiffres, le + et l'espace
    If z.SelLength = Len(z.Text) Then Exit Sub
    'Empcher le '+' ailleurs qu'en premire colonne
    If X% = 43 And z.SelStart > 0 Then X% = 0
    'Empcher plus d'un '+'
    If X% = 43 And InStr(z.Text, "+") > 0 Then X% = 0
    'Empcher une frappe avant le '+'
    If z.SelStart = 0 And InStr(z.Text, "+") > 0 Then X% = 0
    'Empcher 2 espaces conscutifs
    If X% = 32 And z.SelStart > 0 Then If Asc(Mid$(z.Text, z.SelStart)) = 32 Then X% = 0 'Regarde  gauche
    If X% = 32 And Not last Then If Asc(Mid$(z.Text, z.SelStart + 1)) = 32 Then X% = 0 'Regarde  droite
    'Empcher un espace aprs le '+'
    If X% = 32 And z.SelStart > 0 Then If Asc(Mid$(z.Text, z.SelStart)) = 43 Then X% = 0
  Case URL
    If Len(z.Text) >= 4 Then
      If Left$(z.Text, 4) = "http" Then
        MsgBox "Ne tapez pas : 'http://'", vbOKOnly + vbExclamation, ""
        X% = 0
        z.Text = IIf(Len(z.Text) = 4, "", Mid$(z.Text, 5))
      End If
    End If
    Select Case X%
    Case 45 To 57
    Case 65 To 90
    Case 97 To 122
    Case 232, 233
      X% = 101
    Case 224
      X% = 97
    Case 231
      X% = 99
    Case Else
      X% = 0
    End Select
  End Select
End Sub

Public Function NotNumber(code%) As Boolean
  'V 1.0
  'Paramtre : un code ASCII
  'Retour : Vrai si ce n'est pas le code d'un chiffre (0 -9)
  NotNumber = IIf(code% < 48 Or code% > 57, True, False)
End Function

Public Sub Sort(tableau, i, d, dbut, fin)
  'V 2.0
  'Paramtres : un tableau
  '             4 entiers
  'Action : Le tableau est tri sur l'index I de la dimension D (D=1 ou 2)
  'dbut et fin indique la variation de l'index de lignes
  Dim sorted%, j%, k%, swap
  sorted% = False
  Do While Not sorted
    sorted = True
    If d = 2 Then
      For j% = dbut To fin - 1
        If tableau(j%, i) > tableau(j% + 1, i) Then
          For k% = LBound(tableau, 2) To UBound(tableau, 2)
            swap = tableau(j%, k%)
            tableau(j%, k%) = tableau(j% + 1, k%)
            tableau(j% + 1, k%) = swap
          Next
          sorted = False
        End If
      Next
    Else
      For j% = dbut To fin - 1
        If tableau(i, j%) > tableau(i, j% + 1) Then
          For k% = LBound(tableau, 1) To UBound(tableau, 1)
            swap = tableau(k%, j%)
            tableau(k%, j%) = tableau(k%, j% + 1)
            tableau(k%, j% + 1) = swap
          Next
          sorted = False
        End If
      Next
    End If
  Loop
End Sub

Public Function FormatTl$(numro$)
  Dim i%
  For i% = 1 To Len(numro$)
    Select Case Mid$(numro$, i%, 1)
    Case "+"
      FormatTl$ = "00"
    Case 0 To 9
      FormatTl$ = FormatTl$ & Mid$(numro$, i%, 1)
    End Select
  Next
End Function

Public Function StrReplace$(Chaine1$, Chaine2$, Chaine3$)
  'V 1.0
  'Paramtres : 3 chaines
  'Retour : Chaine1 dans laquelle toutes les occurences de Chaine2 sont remplaces par Chaine3
  Dim pos%
  Do
    pos% = InStr(Chaine1$, Chaine2$)
    If pos% > 0 Then
      StrReplace$ = StrReplace$ & Left$(Chaine1$, pos% - 1) & Chaine3$
      pos% = pos% + Len(Chaine2$)
      If pos% <= Len(Chaine1$) Then
        Chaine1$ = Mid$(Chaine1$, pos%)
      Else
        Chaine1$ = ""
      End If
    End If
  Loop Until pos% = 0
  StrReplace$ = StrReplace$ & Chaine1$
End Function

Public Function StripSpace$(chaine$)
  Dim pos%
  StripSpace$ = Trim$(chaine$)
  Do
    pos% = InStr(StripSpace$, " ")
    If pos% > 0 Then StripSpace$ = Left$(StripSpace$, pos% - 1) & Mid$(StripSpace$, pos% + 1)
  Loop Until pos% = 0
End Function

Public Function NoVide$(valeur)
  'V 1.1
  'Paramtre : une chaine reprsentant un nombre ou une chaine vide
  'Retour : La chaine ou "O"
  If Len(valeur) = 0 Then NoVide = "0" Else NoVide = valeur
End Function
